/*
 * This file has been automatically generated by the WICED Smart Designer.
 * BLE device's GATT database and device configuration.
 *
 */

// cookp_lpm_db.c

#include "bleprofile.h"
#include "bleapp.h"
#include "gpiodriver.h"
#include "string.h"
#include "stdio.h"
#include "platform.h"
#include "cookp_lpm_db.h"

/*************************************************************************************
** GATT server definitions
*************************************************************************************/

const UINT8 gatt_database[] = // Define GATT database
{
    /* Primary Service 'Generic Access' */
    // <Name>Generic Access</Name>
    // <Uuid>1800</Uuid>
    // Service handle: HDLS_GENERIC_ACCESS
    // Service UUID: UUID_SERVICE_GAP
    PRIMARY_SERVICE_UUID16 (HDLS_GENERIC_ACCESS, UUID_SERVICE_GAP),

        /* Characteristic 'Device Name' */
        // <Name>Device Name</Name>
        // <Uuid>2A00</Uuid>
        CHARACTERISTIC_UUID16 (HDLC_GENERIC_ACCESS_DEVICE_NAME, HDLC_GENERIC_ACCESS_DEVICE_NAME_VALUE,
            UUID_CHARACTERISTIC_DEVICE_NAME, LEGATTDB_CHAR_PROP_READ,
            LEGATTDB_PERM_NONE, 9),
            'c','o','o','k','p','_','l','p','m',

        /* Characteristic 'Appearance' */
        // <Name>Appearance</Name>
        // <Uuid>2A01</Uuid>
        CHARACTERISTIC_UUID16 (HDLC_GENERIC_ACCESS_APPEARANCE, HDLC_GENERIC_ACCESS_APPEARANCE_VALUE,
            UUID_CHARACTERISTIC_APPEARANCE, LEGATTDB_CHAR_PROP_READ,
            LEGATTDB_PERM_NONE, 2),
            BIT16_TO_8(APPEARANCE_GENERIC_THERMOMETER),

    /* Primary Service 'Generic Attribute' */
    // <Name>Generic Attribute</Name>
    // <Uuid>1801</Uuid>
    // Service handle: HDLS_GENERIC_ATTRIBUTE
    // Service UUID: UUID_SERVICE_GATT
    PRIMARY_SERVICE_UUID16 (HDLS_GENERIC_ATTRIBUTE, UUID_SERVICE_GATT),

};
// Length of the GATT database
const UINT16 gatt_database_len = sizeof(gatt_database);

// Pointer to the bonded peer info or NULL if not bonded
__HOSTINFO *p_bonded = NULL;
// Following structure defines GPIO configuration used by the application
const BLE_PROFILE_GPIO_CFG cookp_lpm_gpio_cfg =
{
    {
        GPIO_PIN_WP,                               // This need to be used to enable/disable NVRAM write protect
        -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 // Other GPIOs are not used
    },
    /*.gpio_flag =*/
    {
        GPIO_SETTINGS_WP,
        0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    }
};

// Main service
UINT8 cookp_lpm_uuid_main_service[2] = {0x01, 0x18};
// Timer counter (for the trace)
UINT32 __timer_count = 0;
// Timer callback function for cookp_lpm_reg_timer
void cookp_lpm_timeout(UINT32 arg)
{
    ble_trace1("timeout:%d\n", __timer_count++);
    if (arg == BLEPROFILE_GENERIC_APP_TIMER)
    {
        cookp_lpm_timer_1s();
    }
}
// Registers timer. Should be called from cookp_lpm_create()
void cookp_lpm_reg_timer()
{
    bleprofile_regTimerCb(NULL, cookp_lpm_timeout);
    bleprofile_StartTimer();
}

// Finds bonded peer in the hostinfo. On exit p_bonded points on bonded peer or NULL
__HOSTINFO *__find_bonded_peer(UINT8 *bda)
{
    int i;
    p_bonded = NULL;
    if (0 == memcmp(bda, p_hostinfo_generated->bdaddr, 6))
    {
        p_bonded = p_hostinfo_generated;
    }
    return p_bonded;
}

// initializes persistent values in the hostinfo to add bonded peer
void cookp_lpm_add_bond(UINT8 *bda)
{
    // Find this peer among bonded peers in the p_hostinfo_generated
    if (!__find_bonded_peer(bda))
    {
        // Peer is not found. Remember new one.
        p_bonded = p_hostinfo_generated;
        memcpy(p_bonded->bdaddr, bda, 6);
    }

    // Clear persistent generated values in the hostinfo for just bonded peer
}

// Prepares generated code for connection - writes persistent values from __HOSTINFO to GATT DB
void __on_connection_up()
{
    // Find this peer among bonded peers in the p_hostinfo_generated
    if (__find_bonded_peer(cookp_lpm_remote_addr))
    {
        BLEPROFILE_DB_PDU db_pdu;
    }
}

// Updates __HOSTINFO by the value written by peer.
// Returns true if any persistent value is changed
BOOL __write_handler(UINT16 handle, int len, UINT8 *attrPtr)
{
    BOOL res = FALSE;
    return res;
}

// It should be called when 'Device Name' is changed.
BOOL store_in_db_generic_access_device_name(UINT8* p_value, UINT8 value_len)
{
    BLEPROFILE_DB_PDU db_pdu;
    // Write value to the GATT DB
    ble_trace2("write len:%d handle:%02x", value_len, HDLC_GENERIC_ACCESS_DEVICE_NAME_VALUE);
    memcpy(&db_pdu.pdu[0], p_value, value_len);
    db_pdu.len = value_len;
    bleprofile_WriteHandle(HDLC_GENERIC_ACCESS_DEVICE_NAME_VALUE, &db_pdu);
    return TRUE;
}

// It should be called when 'Appearance' is changed.
BOOL store_in_db_generic_access_appearance(UINT8* p_value, UINT8 value_len)
{
    BLEPROFILE_DB_PDU db_pdu;
    // Write value to the GATT DB
    ble_trace2("write len:%d handle:%02x", value_len, HDLC_GENERIC_ACCESS_APPEARANCE_VALUE);
    memcpy(&db_pdu.pdu[0], p_value, value_len);
    db_pdu.len = value_len;
    bleprofile_WriteHandle(HDLC_GENERIC_ACCESS_APPEARANCE_VALUE, &db_pdu);
    return TRUE;
}

